/*******************************************************************************

    RELGIO DIGITAL (VERSO 7 SEGUIMENTOS)

    AUTOR: CLAUDIO LRIOS

    DATA: 06/04/2017

    COM  AT89C2051

    C/ 4 DISPLAYS DE 7 SEGUIMENTOS CATODO COMUM.
    MONTE O DISPLAY K1 INVERTIDO (PONTA CABEA) TROCANDO SEGUIMENTOS:
    'a' <-> 'd'
    'b' <-> 'e'
    'c' <-> 'f'
    MANTENDO 'g' e 'P'.

    OBS. MONTAGEM  DE NATUREZA DIDTICA
    USE COMPILADOR MIKROC FOR 8051 V.3.6.0

    ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS
*******************************************************************************/
//BIT
sbit  beep  at P1.B7;  //pino 11

sbit  KA0   at P3.B0;  //pino 2
sbit  KA1   at P3.B2;  //pino 6
sbit  KA2   at P3.B1;  //pino 3
sbit  KA3   at P3.B3;  //pino 7
sbit  SW1   at P3.B4;  //pino 8
sbit  SW2   at P3.B5;  //pino 9

//variveis globais
 char segundos,minutos,horas,botoes; //int8
 bit f_trava;  //flags

//constantes para converso 7 seguimentos

//                         afbedcg.   SEGUIMENTOS
//                      P1 76543210
 const char num[] = {    0B11111100,//0
                         0B00100100,//1
                         0B10111010,//2
                         0B10101110,//3
                         0B01100110,//4
                         0B11001110,//5
                         0B11011110,//6
                         0B10100100,//7
                         0B11111110,//8
                         0B11101110 //9
                                        };
 /******************************************************************************
           MULTIPLEXA OS DISPLAYS
******************************************************************************/

 void multiplexa(){
    static char vez;

   if(++vez>3) vez=0;
    P3|=0B00001111;//CATODO COMUM    (BITS 7,2,1,0 =1)
    P3|=0b00110000; //deixa '1' para testar chaves (bit 4 e 5)
    botoes=P3&0b00110000;// pega a situao dos interruptores (bits 1,2,3,4 PIND)
    P1=0;
    switch (vez){

     case 0: {
       P1=num[horas/10];
       P3= P3&0xfe; break;}
     case 1: {
       P1=num[horas%10];
       P1|=1;//liga ponto
       P3= P3&0xfd; break;}
     case 2: {
       P1=num[minutos/10];
       P1|=1;//liga ponto
       P3= P3&0xfb; break;}
     case 3: {
       P1=num[minutos%10];
       P3= P3&0xf7; break;}

    }

 }

/******************************************************************************
           TESTA INTERRUPTORES DATILARES
******************************************************************************/
void testa_ajuste(){    
//0x30 = nenhum boto acionado; 0x10 boto SW1 ;0x20 = SW2  ; 0x00 = SW1 e SW2 acioandos
  static char vel;

  if(++vel) return;

   switch (botoes){

   case 0: { //SW1 e SW2 apertados juntos (zera H,M e S)
      minutos=0;
      horas=0;
      segundos=0;
      break;
   }

   case 0x10: {//apertado SW1 (ajuste de horas)

    if(++horas>23) horas=0;
    break;
    }
   case 0x20: {//apertado SW2   (ajuste de minutos)

     if(++minutos>59) minutos=0;
     break;
   }
   case 0x30: {f_trava=0;  break;}   //nenhum boto apertado
  }
}

/******************************************************************************
           ROTINA DE INTERRUPO DO TIMER 1
******************************************************************************/
void Timer1InterruptHandler() org IVT_ADDR_ET1{
 static unsigned long cnt32=0;

 //--------------------------------------------------------
//gera 1 segundos com metodo de acumulo de erro
 #define fator  65536
 #define f_xtal 1000000   //frequencia do cristal usado  /12

   cnt32+=fator;
   if(cnt32>=f_xtal){
     cnt32-=f_xtal;

      if(++segundos>59){
        segundos=0;
        if( ++minutos>59){
         minutos=0;
         if(++horas>23) horas=0;
        }
     }

   }
   TF1_bit = 0;       // apaga flag de over flow do Timer1
 }

//==============================================================================
//         ROTINA MAIN
//==============================================================================

void main() {

  TF1_bit = 0;       // apaga flag de over flow do Timer1
  ET1_bit = 1;       // habilita interrupo do Timer1
  EA_bit  = 1;       // habilita interrupo global
  GATE1_bit = 0;     // sem gatilho
  C_T1_bit  = 0;     // ajusta Timer para operar com clock interno.
  M11_bit   = 0;     // M11_M01 = 01    =>   Mode 1(16-bit Timer/Counter)
  M01_bit   = 1;
  TR1_bit = 1;       // liga Timer1
  segundos=0;
  minutos=0;        //valores ps reset
  horas=0;


//==============================================================================
//         LAO DE REPETIO PRINCIPAL
//==============================================================================

   for(;;){
     multiplexa();
     testa_ajuste();
     delay_ms(1);

   }
}